/*      Get and Resume Elite EDition source code


Get and Resume Elite EDition (GREED)
Copyright (C) 1999  Anoakie Turner

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

For more information on the GPL, please go to:
http://www.gnu.org/copyleft/gpl.html


        Contact:  Anoakie Turner
                  Anoakie.Turner@asu.edu

                  13240 N. 94th Pl.
                  Scottsdale, AZ 85260
*/

#include "main.h"


void Proxy()
{	char *file;
	char *buffer;
	char *home;
	struct stat st;
	char *temp = NULL;
	FILE *tempfp;
	char *http_proxy = getenv("HTTP_PROXY");
	int filesize = 0;

	home = malloc(strlen(getenv("HOME")) + strlen("/.greedrc") + 1);
	strcpy(home, getenv("HOME"));

	if (home == NULL)
	{	printf("Non fatal error: Home directory not found, "
			"using current directory.\n");
		home = ".greedrc";
	}
	else
		file = strcat(home, "/.greedrc");

	filesize = 1;
	if (stat(home, &st) != 0)
		if (stat("/etc/greedrc", &st) != 0)
			filesize = 0;
		else
			file = "/etc/greedrc";


	if (filesize == 0)
	{	tempfp = fopen(file, "w+b");

		CreateNewRC(tempfp);
		printf("Configuration file %s created!\n\nRestart greed for the new configuration"
			"to take effect!\n", file);
		fclose (tempfp);
		exit(EXIT_SUCCESS);
	} else
	{	tempfp = fopen(file, "a+b");
		fseek(tempfp, 0L, SEEK_END);
		filesize = ftell(tempfp);

		buffer = malloc(filesize+1);
		rewind(tempfp);
		fread(buffer, filesize, 1, tempfp);
		buffer[filesize+1] = '\0';

		PROXY = ReadString2(strstr(buffer, "SERVER="), 7, '\n');
		PROXYPORT = ReadString2(strstr(buffer, "PORT="), 5, '\n');

		if (PROXY == NULL)
		{	if (http_proxy == NULL)
				http_proxy = getenv("http_proxy");
			if (http_proxy != NULL)
			{	strcpy(temp, http_proxy);
				PROXY = temp + 7;

				if (strchr(temp, ':') == NULL)
					PROXYPORT = "8080";
				else
				{	PROXYPORT = strchr(temp, ':') + 1;
					PROXY[strchr(PROXY, ':') - PROXY] = '\0';
				}
			}
		}

		temp = ReadString2(strstr(buffer, "ROLLBACK="), 9, '\n');
		ROLLBACK = atol(temp);
		free(temp);
		temp = ReadString2(strstr(buffer, "TIMEOUT="), 8, '\n');
		TIMEOUT_SEC = atoi(temp);
		free(temp);
		temp = ReadString2(strstr(buffer, "MINSPEED="), 9, '\n');
		MINSPEED = atoi(temp);
		free(temp);
		temp = ReadString2(strstr(buffer, "WAIT_RETRY="), 11, '\n');
		if (temp == NULL)
			printf("\nNON FATAL ERROR!\nEither you have incorrectly set up your ~/.greedrc, or you need to delete it\n"
				"so GREED can update it to the latest version!\n\"WAIT_RETRY=#\" (where # is"
				" an integer > 0) line missing!\n\n\n");
		else
		{	WAIT_RETRY = atoi(temp);
			free(temp);
		}
		temp = ReadString2(strstr(buffer, "SPEEDUP_FTP="), 12, '\n');
		if (temp == NULL)
			printf("\nNON FATAL ERROR!\nEither you have incorrectly set up your ~/.greedrc, or you need to delete it\n"
				"so GREED can update it to the latest version!\n\"SPEEDUP_FTP=#\" (where # is"
				" an integer >= 0) line missing!\n\n\n");
		else
		{	FTP_WAIT_TIME = atoi(temp);
			free(temp);
		}
	}
	fclose (tempfp);
}

void CreateNewRC(FILE* fp)
{	fwrite("# Proxy server's IP (leave empty if none)\nSERVER=\n\n# Proxy server's PORT\nPORT=8080\n\n",84,1,fp);
	fwrite("# Amount of bytes to download at a time (MUST BE > 1024)\nROLLBACK=4096\n\n# Time out (in ",87,1,fp);
	fwrite("seconds)\nTIMEOUT=300\n\n# Don't download faster then X k/sec (0 for no limit)\nMINSPEED=0",86,1,fp);
	fwrite("\n\n# Time to wait before retrying (in seconds)\nWAIT_RETRY=10\n\n",61,1,fp);
	fwrite("# Speeds up FTP connections by waiting X seconds to send data, a higher number means:\n",86,1,fp);
	fwrite("# higher compatibility, lower speed. (default is 0)\nSPEEDUP_FTP=0\n\n",67,1,fp);
	/*      123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890   */
}
